#pragma once

#include "CoreMinimal.h"
#include "ChargeableInteractionDefinition.h"
#include "DBDTunableRowHandle.h"
#include "CraftPortableSnowmanInteraction.generated.h"

class UChargeableComponent;

UCLASS(Blueprintable, Abstract, EditInlineNew, meta=(BlueprintSpawnableComponent))
class WINTEREVENT2024_API UCraftPortableSnowmanInteraction : public UChargeableInteractionDefinition
{
	GENERATED_BODY()

private:
	UPROPERTY(BlueprintReadWrite, ReplicatedUsing=OnRep_Chargeable, Transient, Instanced, meta=(AllowPrivateAccess=true))
	UChargeableComponent* _chargeable;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _secondsToCharge;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _interactorCooldownDuration;

private:
	UFUNCTION(BlueprintCallable)
	void OnRep_Chargeable();

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	UCraftPortableSnowmanInteraction();
};

FORCEINLINE uint32 GetTypeHash(const UCraftPortableSnowmanInteraction) { return 0; }
